<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org" xmlns:layout="http://www.ultraq.net.nz/web/thymeleaf/layout"
    layout:decorate="layout">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Edit and Add Category</title>
</head>

<body>
    <div layout:fragment="content">

        <div class="container d-flex justify-content-center align-items-end">
            <div class="card text-center w-25">
                <div class="card-header">
                    Thêm Danh Mục
                </div>
                <div class="card-body">

                    <div th:if="${result}" class="d-flex justify-content-center align-items-end">
                        <h4 th:text="${result}" style="color: rgb(13, 153, 29);"></h4>
                    </div>
                    <div th:if="${error}" class="d-flex justify-content-center align-items-end">
                        <h4 th:text="${error}" style="color: red;"></h4>
                    </div>
                    <form id="formAddCategory" th:action="@{/category/add}" method="post">
                        <input type="text" id="nameadd" name="name" class="form-control">
                        <br>
                        <button type="submit" class="btn btn-primary">Thêm</button>
                    </form>

                </div>

            </div>
        </div>
        <br><br>
        <div class="container justify-content-center">
            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">Id</th>
                        <th scope="col">Tên</th>
                        <th scope="col">Hành Động </th>
                    </tr>
                </thead>
                <tbody>
                    <tr th:each="item : ${list_category}">
                        <td th:text="${item.id}"></td>
                        <td th:text="${item.name}"></td>
                        <td>
                            <button type="button" class="btn btn-success edit-btn" data-bs-toggle="modal"
                                data-bs-target="#editCategoryModal" th:attr="data-id=${item.id}">
                                <i class="bi bi-pencil-square"></i>
                            </button>
                            <a th:href="@{'/category/delete/' + ${item.id}}" class="btn btn-danger"
                                onclick="return confirm('Bạn có chắc chắn muốn xóa không?')">
                                <i class="bi bi-trash"></i>
                            </a>
                        </td>
                    </tr>
                </tbody>
            </table>

            <!-- Pagination -->
            <ul class="pagination" th:if="${list_category.totalPages >1}">
                <li class="page-item" th:class="${list_category.first ? 'disabled' : ''}">
                    <a th:if="${name != null}" class="page-link"
                        th:href="@{'/category/search?page=' + ${list_category.number} + '&name=' + ${name}}">&laquo;</a>
                    <a th:unless="${name != null}" class="page-link"
                        th:href="@{'?page=' + ${list_category.number}}">&laquo;</a>
                </li>
                <li th:each="i : ${#numbers.sequence(0, list_category.totalPages - 1)}"
                    th:class="${list_category.number == i ? 'active' : ''}">
                    <a th:if="${name != null}" class="page-link"
                        th:href="@{'/category/search?page=' + (${i+1} ?: 1) + '&name=' + ${name}}" th:text="${i+1}"></a>
                    <a th:unless="${name != null}" class="page-link" th:href="@{'?page=' + ${i+1}} "
                        th:text="${i}+1"></a>
                </li>
                <li class="page-item" th:class="${list_category.last ? 'disabled' : ''}">
                    <a th:if="${name != null}" class="page-link"
                        th:href="@{'/category/search?page=' + ${list_category.number + 2} + '&name=' + ${name}}">&raquo;</a>
                    <a th:unless="${name != null}" class="page-link"
                        th:href="@{'?page=' + ${list_category.number + 2}}">&raquo;</a>
                </li>
            </ul>
        </div>

        <!-- Modal edit category -->
        <div class="modal fade" id="editCategoryModal" tabindex="-1" aria-labelledby="exampleModalLabel"
            aria-hidden="true" data-bs-backdrop="static">
            <div class="modal-dialog">
                <div class="modal-content">
                    <form th:action="@{/category/edit}" method="post" th:object="${category}">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Sửa danh mục</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body ">
                            <div class="d-flex align-items-end justify-content-center ">
                                <h4 class="errormodel" id="erroredit" style="color: red;"></h4>
                            </div>
                            <div id="contentInputEdit" class="d-flex align-items-end justify-content-center ">
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary exitmodel"
                                data-bs-dismiss="modal">Đóng</button>
                            <button type="submit" class="btn btn-primary">Sửa</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        
        <script>


            let messageValidationName = "Tên không được để trống hoặc quá 50 kí tự"
            let maxLengthName = 50
            let url = 'http://localhost:8080/category/api/getbyid/'

            $('#editCategoryModal').submit(function (e) {
                let name = $('#editname').val().trim();
                if (name.trim() === '' || name.length > maxLengthName) {
                    e.preventDefault();
                    $('.errormodel').text(messageValidationName);
                } else {
                    $('#editCategoryModal').submit();
                }
            });

            $('.exitmodel').click(function (e) {
                e.preventDefault();
                $('.errormodel').text("");
            });

            $('.edit-btn').click(function () {
                $('#contentInputEdit').empty();
                var categoryId = $(this).data('id');
                $.ajax({
                    url: url + categoryId,
                    type: 'GET',
                    success: function (data) {

                        console.log(data);
                        $('#contentInputEdit').append('<input type="text" value="' + data.name + '" name="name" class="form-control">');
                        $('#contentInputEdit').append('<input type="hidden" value="' + data.id + '" name="id">');

                    },
                    error: function (xhr, status, error) {
                        console.error('Error:', error);
                    }
                });
            });

        </script>
    </div>
</body>

</html>